unit ParamsCHAC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons;

type
  TfmrParametrosCHAC = class(TForm)
    btnEjecutarCHAC: TButton;
    GroupBox1: TGroupBox;
    lblAltura: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblSemilla: TLabel;
    trLH: TTrackBar;
    edTmpoLimite: TEdit;
    edSemilla: TEdit;
    btnEjecutarBiAnt: TButton;
    shpParametros: TShape;
    lblZVO: TLabel;
    edDistanciaZVO: TEdit;
    GroupBox2: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    edSaludCIA: TEdit;
    edRecursosCIA: TEdit;
    edFicheroMapa: TEdit;
    btnFicheroMapa: TButton;
    Label6: TLabel;
    lblRadioZVO: TLabel;
    dlgAbrirMapa: TOpenDialog;
    Panel2: TPanel;
    edNumIteraciones: TEdit;
    Label11: TLabel;
    Label14: TLabel;
    edNumHormigas: TEdit;
    Label15: TLabel;
    edFicheroSoluciones: TEdit;
    btnFicheroSoluciones: TButton;
    dlgAbrirSoluciones: TOpenDialog;
    btnEjecutarGreedy: TButton;
    Panel4: TPanel;
    Label16: TLabel;
    rbtnRT: TRadioButton;
    rbtnRD: TRadioButton;
    lblRapidoSeguro: TLabel;
    Panel1: TPanel;
    Label5: TLabel;
    chkBL: TCheckBox;
    chkRefinarSols: TCheckBox;
    lblIteracionesBL: TLabel;
    edIteracsBL: TEdit;
    grboxVariasEjecuciones: TGroupBox;
    lblInicial: TLabel;
    edSemillaIni: TEdit;
    lblFinal: TLabel;
    edSemillaFin: TEdit;
    lblIncremento: TLabel;
    edSemillaInc: TEdit;
    chkVariasEjecuciones: TCheckBox;
    grboxDinamismo: TGroupBox;
    lblPasos: TLabel;
    edPasosBusquedaEnemigos: TEdit;
    rbtnEnemConocido: TRadioButton;
    rbtnBuscarEnemigo: TRadioButton;
    lblCada: TLabel;
    lblRadioZVO2: TLabel;
    btnEjecutarMOACS: TButton;
    btnEjecutarCHACmono: TButton;
    btnEjecutarCHAC4: TButton;
    GroupBox3: TGroupBox;
    rbtnANTLBD: TRadioButton;
    rbtnPOSLBD: TRadioButton;
    chkDatosEstadisticas: TCheckBox;
    btnVariasItCHAC: TButton;
    btnCerrar: TBitBtn;
    procedure btnEjecutarCHACClick(Sender: TObject);
    procedure btnEjecutarBiAntClick(Sender: TObject);
    procedure btnFicheroMapaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnFicheroSolucionesClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnEjecutarGreedyClick(Sender: TObject);
    procedure trLHChange(Sender: TObject);
    procedure chkVariasEjecucionesClick(Sender: TObject);
    procedure rbtnBuscarEnemigoClick(Sender: TObject);
    procedure rbtnEnemConocidoClick(Sender: TObject);
    procedure chkBLClick(Sender: TObject);
    procedure btnEjecutarMOACSClick(Sender: TObject);
    procedure btnEjecutarCHACmonoClick(Sender: TObject);
    procedure btnEjecutarCHAC4Click(Sender: TObject);
    procedure btnVariasItCHACClick(Sender: TObject);
    procedure btnCerrarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    num_soluciones: integer;
    fichero_soluciones: string;

    enemigo_conocido: boolean;
  end;

var
  fmrParametrosCHAC: TfmrParametrosCHAC;


implementation

   uses CHAC, CHAC4, Simulador;

{$R *.dfm}

procedure TfmrParametrosCHAC.btnEjecutarCHACClick(Sender: TObject);

var
  sel_nodo, rs, bl, extension, aplic_lambda: string;

  i, semilla, semilla_ini, semilla_fin, semilla_inc: integer;

  enem_conocido: boolean;

begin

   fmrParametrosCHAC.btnEjecutarCHAC.Enabled:=FALSE;

   // se determina cundo se aplicar la restriccin de Lambda
   if (rbtnANTLBD.Checked=TRUE) then
      aplic_lambda:= 'aLBD'
   else
      aplic_lambda:= 'pLBD';

   // se determina cmo se seleccionar el nodo siguiente en el camino
   if (rbtnRT.Checked=TRUE) then
      sel_nodo:= 'RT'
   else
      sel_nodo:= 'RD';

   // se determina si se buscar al enemigo (dinamismo) o si es conocido (si es que existe)
   enem_conocido:= rbtnEnemConocido.Checked;

   // se ejecuta una sola vez
   if (chkVariasEjecuciones.Checked=FALSE) then begin

       // se llama a la funcin del algoritmo
       num_soluciones:= Principal_CHAC(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),aplic_lambda,StrToInt(edDistanciaZVO.Text),
                                       sel_nodo,StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                       StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                       chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                       StrToInt(edSemilla.Text),enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                       fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

       fmrParametrosCHAC.btnEjecutarCHAC.Enabled:=TRUE;

   end
   else begin

       // se inicializa la semilla
       semilla_ini:=StrToInt(edSemillaIni.Text);
       semilla_fin:=StrToInt(edSemillaFin.Text);
       semilla_inc:=StrToInt(edSemillaInc.Text);
       semilla:= semilla_ini;

       // camino ms rpido o ms seguro
       // camino ms rpido o ms seguro
       if (trLH.Position <= 50) then begin
          if (trLH.Position = 50) then rs:='rs'
          else rs:='+r';
       end
       else rs:='+s';

       // con bsqueda local (n iteraciones) o sin ella
       if (chkBL.Checked=TRUE) then
          bl:= ',LS(' + edIteracsBL.Text + ')'
       else bl:='';

       for i:=semilla_ini to semilla_fin do begin

          // se actualiza el nombre del fichero de soluciones
          extension:= ' [' + sel_nodo + bl + ',s' + IntToStr(semilla) + ',' +
                      edNumIteraciones.Text + 'it,' + edNumHormigas.Text + 'a,' + rs + '_' +
                      aplic_lambda + ']'+ '.sol';
          fichero_soluciones:=  ChangeFileExt(edFicheroSoluciones.Text,extension);

          // se llama a la funcin del algoritmo
          num_soluciones:= Principal_CHAC(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),aplic_lambda,StrToInt(edDistanciaZVO.Text),
                                          sel_nodo,StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                          StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                          chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                          semilla,enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                          fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

          // se actualiza la semilla
          semilla:=semilla+semilla_inc;

       end;

       fmrParametrosCHAC.btnEjecutarCHAC.Enabled:=TRUE;

       showmessage('END of Running. Close the Window to see the solutions');

   end;

//   fmrParametrosCHAC.shpParametros.Cursor:= crDefault;

end;

procedure TfmrParametrosCHAC.btnEjecutarGreedyClick(Sender: TObject);
var
  extension: string;

  i, semilla, semilla_ini, semilla_fin, semilla_inc: integer;

begin

   fmrParametrosCHAC.btnEjecutarGreedy.Enabled:=FALSE;

   // se ejecuta una sola vez
   if (chkVariasEjecuciones.Checked=FALSE) then begin

       // se llama a la funcin del algoritmo
       num_soluciones:= Principal_Greedy(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),StrToInt(edDistanciaZVO.Text),
                                         StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),StrToInt(edNumIteraciones.Text),
                                         chkRefinarSols.Checked,StrToInt(edSemilla.Text),fichero_soluciones,chkVariasEjecuciones.Checked,
                                         chkDatosEstadisticas.Checked);

       fmrParametrosCHAC.btnEjecutarCHAC.Enabled:=TRUE;

   end
   else begin

       // se inicializa la semilla
       semilla_ini:=StrToInt(edSemillaIni.Text);
       semilla_fin:=StrToInt(edSemillaFin.Text);
       semilla_inc:=StrToInt(edSemillaInc.Text);
       semilla:= semilla_ini;


       for i:=semilla_ini to semilla_fin do begin

          // se actualiza el nombre del fichero de soluciones
          extension:= ' [' + 'GRDYMO' + ',s' + IntToStr(semilla) + ',' +
                      edNumIteraciones.Text + 'it' + ']'+ '.sol';
          fichero_soluciones:=  ChangeFileExt(edFicheroSoluciones.Text,extension);

          // se llama a la funcin del algoritmo
          num_soluciones:= Principal_Greedy(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),StrToInt(edDistanciaZVO.Text),
                                            StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),StrToInt(edNumIteraciones.Text),
                                            chkRefinarSols.Checked,semilla,fichero_soluciones,chkVariasEjecuciones.Checked,
                                            chkDatosEstadisticas.Checked);

          // se actualiza la semilla
          semilla:=semilla+semilla_inc;

       end;

       fmrParametrosCHAC.btnEjecutarGreedy.Enabled:=TRUE;

       showmessage('END of Running. Close the Window to see the solutions');

   end;

end;

procedure TfmrParametrosCHAC.btnEjecutarBiAntClick(Sender: TObject);
var
  rs, bl, extension, aplic_lambda: string;

  i, semilla, semilla_ini, semilla_fin, semilla_inc: integer;

  enem_conocido: boolean;

begin

   fmrParametrosCHAC.btnEjecutarBiAnt.Enabled:=FALSE;

   // se determina cundo se aplicar la restriccin de Lambda
   // si sera FIJO para todas las hormigas o VARIABLE (uno para cada una)
   if (rbtnANTLBD.Checked=TRUE) then
      aplic_lambda:= 'aLBD'
   else
      aplic_lambda:= 'pLBD';

   // se determina si se buscar al enemigo (dinamismo) o si es conocido (si es que existe)
   enem_conocido:= rbtnEnemConocido.Checked;

   // se ejecuta una sola vez
   if (chkVariasEjecuciones.Checked=FALSE) then begin

       // se llama a la funcin del algoritmo
       num_soluciones:= Principal_BiAnt(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),aplic_lambda,StrToInt(edDistanciaZVO.Text),
                                       StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                       StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                       chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                       StrToInt(edSemilla.Text),enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                       fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

       fmrParametrosCHAC.btnEjecutarBiAnt.Enabled:=TRUE;

   end
   else begin

       // se inicializa la semilla
       semilla_ini:=StrToInt(edSemillaIni.Text);
       semilla_fin:=StrToInt(edSemillaFin.Text);
       semilla_inc:=StrToInt(edSemillaInc.Text);
       semilla:= semilla_ini;

       // camino ms rpido o ms seguro
       // camino ms rpido o ms seguro
       if (trLH.Position <= 50) then begin
          if (trLH.Position = 50) then rs:='rs'
          else rs:='+r';
       end
       else rs:='+s';

       // con bsqueda local (n iteraciones) o sin ella
       if (chkBL.Checked=TRUE) then
          bl:= ',LS(' + edIteracsBL.Text + ')'
       else bl:='';

       for i:=semilla_ini to semilla_fin do begin

          // se actualiza el nombre del fichero de soluciones
          extension:= ' [' + 'BiAnt' + bl + ',s' + IntToStr(semilla) + ',' +
                      edNumIteraciones.Text + 'it,' + edNumHormigas.Text + 'a,' + rs + ']'+ '.sol';
          fichero_soluciones:=  ChangeFileExt(edFicheroSoluciones.Text,extension);

          // se llama a la funcin del algoritmo
          num_soluciones:= Principal_BiAnt(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),aplic_lambda,StrToInt(edDistanciaZVO.Text),
                                          StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                          StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                          chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                          semilla,enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                          fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

          // se actualiza la semilla
          semilla:=semilla+semilla_inc;

       end;

       fmrParametrosCHAC.btnEjecutarBiAnt.Enabled:=TRUE;

       showmessage('END of Running. Close the Window to see the solutions');

   end;

end;

procedure TfmrParametrosCHAC.btnFicheroMapaClick(Sender: TObject);
begin

  dlgAbrirMapa.InitialDir := GetCurrentDir;

  // Se muestra el Dilogo para Abrir el Fichero del Mapa
  if dlgAbrirMapa.Execute then begin
     edFicheroMapa.Text:= dlgAbrirMapa.FileName;
     edFicheroSoluciones.Text:= ChangeFileExt(edFicheroMapa.Text,'.sol');
     fichero_soluciones:= edFicheroSoluciones.Text;
  end;

end;

procedure TfmrParametrosCHAC.btnFicheroSolucionesClick(Sender: TObject);
begin

  dlgAbrirSoluciones.InitialDir := GetCurrentDir;
//  dlgAbrirSoluciones.FileName := edFicheroSoluciones.Text;

  // Se muestra el Dilogo para Abrir el Fichero del Mapa
  if dlgAbrirSoluciones.Execute then begin
     edFicheroSoluciones.Text:= dlgAbrirSoluciones.FileName;
     fichero_soluciones:= edFicheroSoluciones.Text;
  end;

end;

procedure TfmrParametrosCHAC.FormCreate(Sender: TObject);
begin
   num_soluciones:= 0;
   fichero_soluciones:= '';
   edDistanciaZVO.Text:= intToStr(CAP_ADQ_UNI);
end;

procedure TfmrParametrosCHAC.FormActivate(Sender: TObject);
begin

   if (fichero_soluciones='') then begin
       edFicheroSoluciones.Text:= ChangeFileExt(edFicheroMapa.Text,'.sol');
       fichero_soluciones:= edFicheroSoluciones.Text;
   end;

   if (enemigo_conocido=TRUE) then begin
      lblZVO.Enabled:=FALSE;
      lblRadioZVO.Enabled:=FALSE;
      lblRadioZVO2.Enabled:=FALSE;
      edDistanciaZVO.Enabled:=FALSE;
   end
   else begin
      lblZVO.Enabled:=TRUE;
      lblRadioZVO.Enabled:=TRUE;
      lblRadioZVO2.Enabled:=TRUE;
      edDistanciaZVO.Enabled:=TRUE;
   end;

end;

procedure TfmrParametrosCHAC.trLHChange(Sender: TObject);
begin
   lblRapidoSeguro.Caption:= '[ ' + IntToStr(100-trLH.Position) + '%  |  ' +
                                    IntToStr(trLH.Position) + '% ]';
end;

procedure TfmrParametrosCHAC.chkVariasEjecucionesClick(Sender: TObject);
begin

   if (chkVariasEjecuciones.Checked=TRUE) then begin
       grboxVariasEjecuciones.Enabled:= TRUE;
       edSemillaIni.Enabled:= TRUE;
       lblInicial.Enabled:= TRUE;
       edSemillaFin.Enabled:= TRUE;
       lblFinal.Enabled:= TRUE;
       edSemillaInc.Enabled:= TRUE;
       lblIncremento.Enabled:= TRUE;
       edSemilla.Enabled:= FALSE;
       lblSemilla.Enabled:= FALSE;
   end
   else begin
       grboxVariasEjecuciones.Enabled:= FALSE;
       edSemillaIni.Enabled:= FALSE;
       lblInicial.Enabled:= FALSE;
       edSemillaFin.Enabled:= FALSE;
       lblFinal.Enabled:= FALSE;
       edSemillaInc.Enabled:= FALSE;
       lblIncremento.Enabled:= FALSE;
       edSemilla.Enabled:= TRUE;
       lblSemilla.Enabled:= TRUE;
   end;

end;

procedure TfmrParametrosCHAC.rbtnBuscarEnemigoClick(Sender: TObject);
begin
   lblCada.Enabled:= TRUE;
   edPasosBusquedaEnemigos.Enabled:= TRUE;
   lblPasos.Enabled:= TRUE;
end;

procedure TfmrParametrosCHAC.rbtnEnemConocidoClick(Sender: TObject);
begin
   lblCada.Enabled:= FALSE;
   edPasosBusquedaEnemigos.Enabled:= FALSE;
   lblPasos.Enabled:= FALSE;
end;

procedure TfmrParametrosCHAC.chkBLClick(Sender: TObject);
begin
   edIteracsBL.Enabled:= chkBL.Checked;
   lblIteracionesBL.Enabled:= chkBL.Checked;
end;

procedure TfmrParametrosCHAC.btnEjecutarMOACSClick(Sender: TObject);
var
  rs, bl, extension, aplic_lambda: string;

  i, semilla, semilla_ini, semilla_fin, semilla_inc: integer;

  enem_conocido: boolean;

begin

   fmrParametrosCHAC.btnEjecutarMOACS.Enabled:=FALSE;

   // se determina cundo se aplicar la restriccin de Lambda
   // si sera FIJO para todas las hormigas o VARIABLE (uno para cada una)
   if (rbtnANTLBD.Checked=TRUE) then
      aplic_lambda:= 'aLBD'
   else
      aplic_lambda:= 'pLBD';

   // se determina si se buscar al enemigo (dinamismo) o si es conocido (si es que existe)
   enem_conocido:= rbtnEnemConocido.Checked;

   // se ejecuta una sola vez
   if (chkVariasEjecuciones.Checked=FALSE) then begin

       // se llama a la funcin del algoritmo
       num_soluciones:= Principal_MOACS(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),aplic_lambda,StrToInt(edDistanciaZVO.Text),
                                       StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                       StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                       chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                       StrToInt(edSemilla.Text),enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                       fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

       fmrParametrosCHAC.btnEjecutarMOACS.Enabled:=TRUE;

   end
   else begin

       // se inicializa la semilla
       semilla_ini:=StrToInt(edSemillaIni.Text);
       semilla_fin:=StrToInt(edSemillaFin.Text);
       semilla_inc:=StrToInt(edSemillaInc.Text);
       semilla:= semilla_ini;

       // camino ms rpido o ms seguro
       // camino ms rpido o ms seguro
       if (trLH.Position <= 50) then begin
          if (trLH.Position = 50) then rs:='rs'
          else rs:='+r';
       end
       else rs:='+s';

       // con bsqueda local (n iteraciones) o sin ella
       if (chkBL.Checked=TRUE) then
          bl:= ',LS(' + edIteracsBL.Text + ')'
       else bl:='';

       for i:=semilla_ini to semilla_fin do begin

          // se actualiza el nombre del fichero de soluciones
          extension:= ' [' + 'MOACS' + bl + ',s' + IntToStr(semilla) + ',' +
                      edNumIteraciones.Text + 'it,' + edNumHormigas.Text + 'a,' + rs + ']'+ '.sol';
          fichero_soluciones:=  ChangeFileExt(edFicheroSoluciones.Text,extension);

          // se llama a la funcin del algoritmo
          num_soluciones:= Principal_MOACS(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),aplic_lambda,StrToInt(edDistanciaZVO.Text),
                                          StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                          StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                          chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                          semilla,enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                          fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

          // se actualiza la semilla
          semilla:=semilla+semilla_inc;

       end;

       fmrParametrosCHAC.btnEjecutarMOACS.Enabled:=TRUE;

       showmessage('END of Running. Close the Window to see the solutions');

   end;

end;

procedure TfmrParametrosCHAC.btnEjecutarCHACmonoClick(Sender: TObject);
var
  rs, bl, extension: string;

  i, semilla, semilla_ini, semilla_fin, semilla_inc: integer;

  enem_conocido: boolean;

begin

   fmrParametrosCHAC.btnEjecutarCHACmono.Enabled:=FALSE;

   // se determina si se buscar al enemigo (dinamismo) o si es conocido (si es que existe)
   enem_conocido:= rbtnEnemConocido.Checked;

   // se ejecuta una sola vez
   if (chkVariasEjecuciones.Checked=FALSE) then begin

       // se llama a la funcin del algoritmo
       num_soluciones:= Principal_CHACmono(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),StrToInt(edDistanciaZVO.Text),
                                       StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                       StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                       chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                       StrToInt(edSemilla.Text),enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                       fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

       fmrParametrosCHAC.btnEjecutarCHACmono.Enabled:=TRUE;

   end
   else begin

       // se inicializa la semilla
       semilla_ini:=StrToInt(edSemillaIni.Text);
       semilla_fin:=StrToInt(edSemillaFin.Text);
       semilla_inc:=StrToInt(edSemillaInc.Text);
       semilla:= semilla_ini;

       // camino ms rpido o ms seguro
       // camino ms rpido o ms seguro
       if (trLH.Position <= 50) then begin
          if (trLH.Position = 50) then rs:='rs'
          else rs:='+r';
       end
       else rs:='+s';

       // con bsqueda local (n iteraciones) o sin ella
       if (chkBL.Checked=TRUE) then
          bl:= ',LS(' + edIteracsBL.Text + ')'
       else bl:='';

       for i:=semilla_ini to semilla_fin do begin

          // se actualiza el nombre del fichero de soluciones
          extension:= ' [' + 'monoCHAC' + bl + ',s' + IntToStr(semilla) + ',' +
                      edNumIteraciones.Text + 'it,' + edNumHormigas.Text + 'a,' + rs + ']'+ '.sol';
          fichero_soluciones:=  ChangeFileExt(edFicheroSoluciones.Text,extension);

          // se llama a la funcin del algoritmo
          num_soluciones:= Principal_CHACmono(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),StrToInt(edDistanciaZVO.Text),
                                          StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                          StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                          chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                          semilla,enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                          fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);


          // se actualiza la semilla
          semilla:=semilla+semilla_inc;

       end;

       fmrParametrosCHAC.btnEjecutarCHACmono.Enabled:=TRUE;

       showmessage('END of Running. Close the Window to see the solutions');

   end;


end;

procedure TfmrParametrosCHAC.btnEjecutarCHAC4Click(Sender: TObject);

var
  sel_nodo, rs, bl, extension, aplic_lambda: string;

  i, semilla, semilla_ini, semilla_fin, semilla_inc: integer;

  enem_conocido: boolean;

begin

   fmrParametrosCHAC.btnEjecutarCHAC.Enabled:=FALSE;

   // se determina cundo se aplicar la restriccin de Lambda
   // si sera FIJO para todas las hormigas o VARIABLE (uno para cada una)
   if (rbtnANTLBD.Checked=TRUE) then
      aplic_lambda:= 'aLBD'
   else
      aplic_lambda:= 'pLBD';

   // se determina cmo se seleccionar el nodo siguiente en el camino
   if (rbtnRT.Checked=TRUE) then
      sel_nodo:= 'RT'
   else
      sel_nodo:= 'RD';

   // se determina si se buscar al enemigo (dinamismo) o si es conocido (si es que existe)
   enem_conocido:= rbtnEnemConocido.Checked;

   // se ejecuta una sola vez
   if (chkVariasEjecuciones.Checked=FALSE) then begin

       // se llama a la funcin del algoritmo
       num_soluciones:= Principal_CHAC_4objs(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),aplic_lambda,StrToInt(edDistanciaZVO.Text),
                                             sel_nodo,StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                             StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                             chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                             StrToInt(edSemilla.Text),enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                             fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

       fmrParametrosCHAC.btnEjecutarCHAC.Enabled:=TRUE;

   end
   else begin

       // se inicializa la semilla
       semilla_ini:=StrToInt(edSemillaIni.Text);
       semilla_fin:=StrToInt(edSemillaFin.Text);
       semilla_inc:=StrToInt(edSemillaInc.Text);
       semilla:= semilla_ini;

       // camino ms rpido o ms seguro
       if (trLH.Position <= 50) then begin
          if (trLH.Position = 50) then rs:='rs'
          else rs:='+r';
       end
       else rs:='+s';

       // con bsqueda local (n iteraciones) o sin ella
       if (chkBL.Checked=TRUE) then
          bl:= ',LS(' + edIteracsBL.Text + ')'
       else bl:='';

       for i:=semilla_ini to semilla_fin do begin

          // se actualiza el nombre del fichero de soluciones
          extension:= ' [' + sel_nodo + bl + ',s' + IntToStr(semilla) + ',' +
                      edNumIteraciones.Text + 'it,' + edNumHormigas.Text + 'a,' + rs + ']'+ '.sol';
          fichero_soluciones:=  ChangeFileExt(edFicheroSoluciones.Text,extension);

          // se llama a la funcin del algoritmo
          num_soluciones:= Principal_CHAC_4objs(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),aplic_lambda,StrToInt(edDistanciaZVO.Text),
                                                sel_nodo,StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                                StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                                chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                                semilla,enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                                fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

          // se actualiza la semilla
          semilla:=semilla+semilla_inc;

       end;

       fmrParametrosCHAC.btnEjecutarCHAC.Enabled:=TRUE;

       showmessage('END of Running. Close the Window to see the solutions');

   end;


end;

// -----------------------------------------------------------------------------

procedure TfmrParametrosCHAC.btnVariasItCHACClick(Sender: TObject);

var
  sel_nodo, rs, bl, extension, aplic_lambda: string;

  i, it_i, it_j, semilla, semilla_ini, semilla_fin, semilla_inc: integer;

  enem_conocido: boolean;

  NumIteraciones, NumHormigas: integer;

begin

   // se determina cundo se aplicar la restriccin de Lambda
   if (rbtnANTLBD.Checked=TRUE) then
      aplic_lambda:= 'aLBD'
   else
      aplic_lambda:= 'pLBD';

   // se determina cmo se seleccionar el nodo siguiente en el camino
   if (rbtnRT.Checked=TRUE) then
      sel_nodo:= 'RT'
   else
      sel_nodo:= 'RD';

   // se determina si se buscar al enemigo (dinamismo) o si es conocido (si es que existe)
   enem_conocido:= rbtnEnemConocido.Checked;

   // se ejecuta una sola vez
   if (chkVariasEjecuciones.Checked=FALSE) then begin

       // se llama a la funcin del algoritmo
       num_soluciones:= Principal_CHAC(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),aplic_lambda,StrToInt(edDistanciaZVO.Text),
                                       sel_nodo,StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                       StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                       chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                       StrToInt(edSemilla.Text),enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                       fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

       fmrParametrosCHAC.btnEjecutarCHAC.Enabled:=TRUE;

   end
   else begin

       // camino ms rpido o ms seguro
       // camino ms rpido o ms seguro
       if (trLH.Position <= 50) then begin
          if (trLH.Position = 50) then rs:='rs'
          else rs:='+r';
       end
       else rs:='+s';

       // con bsqueda local (n iteraciones) o sin ella
       if (chkBL.Checked=TRUE) then
          bl:= ',LS(' + edIteracsBL.Text + ')'
       else bl:='';

       (* iteraciones con diferentes configuraciones de iteraciones y hormigas *)

       NumIteraciones:= 800;

       for it_i:=1 to 3 do begin

       NumHormigas:= 20;

       for it_j:=1 to 3 do begin

          edNumIteraciones.Text:= IntToStr(NumIteraciones);
          edNumHormigas.Text:= IntToStr(NumHormigas);

          // se inicializa la semilla
          semilla_ini:=StrToInt(edSemillaIni.Text);
          semilla_fin:=StrToInt(edSemillaFin.Text);
          semilla_inc:=StrToInt(edSemillaInc.Text);
          semilla:= semilla_ini;

          for i:=semilla_ini to semilla_fin do begin

             // se actualiza el nombre del fichero de soluciones
             extension:= ' [' + sel_nodo + bl + ',s' + IntToStr(semilla) + ',' +
                         edNumIteraciones.Text + 'it,' + edNumHormigas.Text + 'a,' + rs + '_' +
                         aplic_lambda + ']'+ '.sol';
             fichero_soluciones:=  ChangeFileExt(edFicheroSoluciones.Text,extension);

             // se llama a la funcin del algoritmo
             num_soluciones:= Principal_CHAC(edFicheroMapa.Text,(1.0-(trLH.Position/100.0)),aplic_lambda,StrToInt(edDistanciaZVO.Text),
                                             sel_nodo,StrToInt(edSaludCIA.Text),StrToInt(edRecursosCIA.Text),
                                             StrToInt(edNumIteraciones.Text),StrToInt(edNumHormigas.Text),
                                             chkBL.Checked,StrToInt(edIteracsBL.Text),chkRefinarSols.Checked,
                                             semilla,enem_conocido,StrToInt(edPasosBusquedaEnemigos.Text),
                                             fichero_soluciones,chkVariasEjecuciones.Checked,chkDatosEstadisticas.Checked);

             // se actualiza la semilla
             semilla:=semilla+semilla_inc;

          end; // fin i

          NumHormigas:= NumHormigas + 30;

       end;  // fin it_j

       NumIteraciones:= NumIteraciones + 700;

       end;  // fin it_i


       showmessage('END of Running. Close the Window to see the solutions');

   end;

end;

procedure TfmrParametrosCHAC.btnCerrarClick(Sender: TObject);
begin
  Close;
end;

end.
